Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog2.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog2.java	(revision 0)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog2.java	(revision 3022)
@@ -0,0 +1,200 @@
+package org.txm.rcp.swt.widget.parameters;
+
+import java.io.File;
+import java.io.FileReader;
+import java.io.FileWriter;
+import java.io.IOException;
+import java.lang.reflect.Field;
+import java.text.ParseException;
+import java.util.ArrayList;
+import java.util.Date;
+import java.util.HashMap;
+import java.util.LinkedHashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Properties;
+
+import org.apache.commons.lang.StringUtils;
+import org.eclipse.jface.dialogs.Dialog;
+import org.eclipse.jface.dialogs.IDialogConstants;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.SelectionAdapter;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Control;
+import org.eclipse.swt.widgets.Display;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Shell;
+import org.kohsuke.args4j.CmdLineParser;
+import org.kohsuke.args4j.NamedOptionDef;
+import org.kohsuke.args4j.spi.OptionHandler;
+import org.txm.Toolbox;
+import org.txm.rcp.messages.TXMUIMessages;
+import org.txm.rcp.swt.GLComposite;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
+import org.txm.utils.Timer;
+import org.txm.utils.logger.Log;
+
+@SuppressWarnings("rawtypes")
+public class ParametersDialog2 extends Dialog {
+	
+	// protected ArrayList<NamedOptionDef> parameters;
+	
+	protected String title;
+	
+	protected ParametersManager manager;
+	
+	protected ParametersGLComposite columns;
+	
+	/**
+	 * Don't forget to call init(...) to setup the parameters to show
+	 * 
+	 * @param parentShell
+	 */
+	public ParametersDialog2(Shell parentShell) {
+		super(parentShell);
+		
+		// init(allParameters, defaultParameters);
+	}
+	
+	/**
+	 * 
+	 * @param parentShell
+	 * @param bean
+	 * @param allParameters all the scripts annotations
+	 * @param args pre-filled fields
+	 */
+	public ParametersDialog2(Shell parentShell, List<OptionHandler> allParameters, Map<String, Object> defaultParameters) {
+		super(parentShell);
+		
+		init(allParameters, defaultParameters);
+	}
+	
+	public void init(List<OptionHandler> allParameters, Map<String, Object> defaultParameters) {
+		
+		setShellStyle(getShellStyle() | SWT.RESIZE);
+		
+		manager = new ParametersManager();
+		ArrayList<NamedOptionDef> parameters = new ArrayList<>();
+		if (allParameters != null) {
+			for (OptionHandler opt : allParameters) {
+				if (opt.option instanceof NamedOptionDef) {
+					parameters.add((NamedOptionDef) opt.option);
+				}
+			}
+		}
+		
+		manager.setParametersOptions(parameters);
+		
+		manager.updateDefaultValues(defaultParameters);
+	}
+	
+	/*
+	 * (non-Javadoc)
+	 * @see org.eclipse.jface.window.Window#configureShell(org.eclipse.swt.widgets.Shell)
+	 */
+	@Override
+	protected void configureShell(Shell newShell) {
+		super.configureShell(newShell);
+		
+		newShell.setText(title);
+		newShell.setMinimumSize(250, 450);
+	}
+	
+	public ParametersManager getParameterManager() {
+		return manager;
+	}
+	
+	public ParametersGLComposite getParameterWidgets() {
+		return columns;
+	}
+	
+	@Override
+	protected boolean isResizable() {
+		return true;
+	}
+	
+	@Override
+	protected void createButtonsForButtonBar(Composite parent) {
+		// create the reset button (hack of the Back button)
+		// Button propButton = createButton(parent, IDialogConstants.BACK_ID,
+		// "...", false);
+		// propButton.removeListener(SWT.Selection, propButton.getListeners(SWT.Selection)[0]);
+		//
+		// propButton.addSelectionListener(new SelectionAdapter() {
+		// @Override
+		// public void widgetSelected(SelectionEvent e) {
+		// FileDialog dialog = new FileDialog(e.display.getActiveShell());
+		// dialog.setFilterPath(propFile.getParent());
+		// dialog.setFilterExtensions(new String[] {"*.properties"});
+		// dialog.setFileName(propFile.getName());
+		// String path = dialog.open();
+		// if (path != null) {
+		// propFile = new File(path);
+		// loadDefaultValuesFromPropFile();
+		// }
+		// }
+		// });
+		
+		Button button = createButton(parent, IDialogConstants.BACK_ID, "Reset values", false);
+		button.removeListener(SWT.Selection, button.getListeners(SWT.Selection)[0]);
+		
+		button.addSelectionListener(new SelectionAdapter() {
+			
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				columns.resetWidgets();
+			}
+		});
+		button.setEnabled(columns.getNumberOfFields() > 0);
+		
+		super.createButtonsForButtonBar(parent);
+		this.getButton(IDialogConstants.OK_ID).setText(TXMUIMessages.run);
+	}
+	
+	/*
+	 * (non-Javadoc)
+	 * @see org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets.Composite)
+	 */
+	@Override
+	protected Control createDialogArea(Composite composite) {
+		// this.parent = composite;
+		super.createDialogArea(composite);
+		
+		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
+		GridLayout layout = new GridLayout(1, true);
+		composite.setLayout(layout);
+		
+		columns = new ParametersGLComposite(composite, SWT.NONE, "parameters", this.manager);
+		
+		new Label(composite, SWT.NONE).setText(TXMUIMessages.mandatoryFields);
+		
+		return composite;
+	}
+	
+	/*
+	 * (non-Javadoc)
+	 * @see org.eclipse.jface.dialogs.Dialog#okPressed()
+	 */
+	@Override
+	protected void okPressed() {
+		ArrayList<String> missing = columns.getNonSetFields();
+		if (missing.size() > 0) {
+			System.out.println(TXMUIMessages.errorColonMissingValueColon + StringUtils.join(missing, ", "));
+			return; // abort
+		}
+		
+		super.okPressed();
+	}
+	
+	public HashMap<String, Object> getValues() {
+		return manager.getFinalValues();
+	}
+	
+	public boolean getMustShowDialog() {
+		return columns != null && columns.mustShowDialog;
+	}
+}

Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/MacroParametersDialog.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/MacroParametersDialog.java	(revision 0)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/MacroParametersDialog.java	(revision 3022)
@@ -0,0 +1,224 @@
+package org.txm.rcp.swt.widget.parameters;
+
+import java.io.File;
+import java.io.FileReader;
+import java.io.FileWriter;
+import java.io.IOException;
+import java.util.LinkedHashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Properties;
+import java.util.concurrent.Callable;
+
+import org.apache.commons.lang.StringUtils;
+import org.eclipse.osgi.util.NLS;
+import org.eclipse.swt.widgets.Display;
+import org.eclipse.swt.widgets.Shell;
+import org.kohsuke.args4j.CmdLineParser;
+import org.kohsuke.args4j.NamedOptionDef;
+import org.kohsuke.args4j.spi.OptionHandler;
+import org.txm.Toolbox;
+import org.txm.rcp.messages.TXMUIMessages;
+import org.txm.utils.Timer;
+import org.txm.utils.logger.Log;
+
+public class MacroParametersDialog extends ParametersDialog2 {
+	
+	Object bean;
+	
+	File propFile;
+	
+	/**
+	 * 
+	 * @param parentShell
+	 * @param bean
+	 * @param allParameters all the scripts annotations
+	 * @param args pre-filled fields
+	 */
+	public MacroParametersDialog(Shell parentShell, Object bean) {
+		super(parentShell);
+		
+		if (bean != null) {
+			this.bean = bean;
+			CmdLineParser parser = new CmdLineParser(bean);
+			List<OptionHandler> options = parser.getOptions();
+			
+			Object oArgs = null;
+			if (bean instanceof groovy.lang.Script) {
+				groovy.lang.Script script = (groovy.lang.Script) bean;
+				
+				// if the "args" variable exists then use its values. Can be used to set a default value by another Macro
+				if (script.getBinding().hasVariable("args")) {
+					oArgs = script.getBinding().getVariable("args"); //$NON-NLS-1$
+				}
+			}
+			
+			Map<String, Object> args;
+			if (oArgs == null || !(oArgs instanceof Map)) {
+				args = new LinkedHashMap<>();
+			}
+			else {
+				args = (Map) oArgs;
+			}
+			
+			if (bean instanceof groovy.lang.Script) { // create the args binding if not already existing
+				groovy.lang.Script script = (groovy.lang.Script) bean;
+				if (!script.getBinding().hasVariable("args")) {
+					script.getBinding().setVariable("args", args);
+				}
+			}
+			
+			String script = bean.getClass().getName();
+			
+			int idx2 = script.lastIndexOf("Macro");
+			if (idx2 < 0) idx2 = script.length();
+			title = TXMUIMessages.bind(TXMUIMessages.p0ParametersInput, script.substring(script.lastIndexOf(".") + 1, idx2));
+			
+			// initialize the properties file default values store
+			String scriptRootDir = Toolbox.getTxmHomePath() + "/scripts/groovy/user"; //$NON-NLS-1$
+			
+			propFile = new File(scriptRootDir, script.replace(".", "/") + ".properties");
+			Properties defaultValuesProperties = loadDefaultValuesFromPropFile();
+			for (Object k : defaultValuesProperties.keySet()) {
+				if (!args.containsKey(k)) {
+					args.put(k.toString(), defaultValuesProperties.get(k));
+				}
+			}
+			
+			init(options, args);
+		}
+	}
+	
+	
+	public boolean saveDefaultParameters() {
+		try {
+			propFile.getParentFile().mkdirs();
+			manager.finalToProperties().store(new FileWriter(propFile), "");
+			return true;
+		}
+		catch (IOException e) {
+			System.out.println("Warning: failed to store default macro valuesin " + propFile + ": " + e);
+			Log.printStackTrace(e);
+			return false;
+		}
+	}
+	
+	public Properties loadDefaultValuesFromPropFile() {
+		Properties defaultValues = new Properties();
+		if (propFile.exists()) {
+			try {
+				defaultValues.load(new FileReader(propFile));
+				Log.info("Retrieving previous macro parameters from " + propFile + " values=" + defaultValues.entrySet() + "...");
+			}
+			catch (Exception e) {
+				Log.severe("Failed to load previous values from " + propFile + ": " + e);
+				Log.printStackTrace(e);
+			}
+		}
+		return defaultValues;
+	}
+	
+	/**
+	 * Conveniance method to initialize the parameters dialog.
+	 * Can detect the "args" Groovy binding and use it to set variables
+	 * If all variables are set by "args" then don't show the dialog box
+	 * 
+	 * @param bean
+	 * @return true if the user has clicked on the "OK" button
+	 */
+	public static boolean open(final Object bean) {
+		
+		Callable<Boolean> r = new Callable<Boolean>() {
+			
+			Boolean called = null;
+			
+			boolean errorOpen = true;
+			
+			boolean retOpen = false;
+			
+			public boolean returnCode() {
+				called = retOpen && !errorOpen;
+				return called;
+			}
+			
+			@Override
+			public Boolean call() throws Exception {
+				if (called != null) return called; // exit if already called
+				
+				MacroParametersDialog dialog = new MacroParametersDialog(Display.getCurrent().getActiveShell(), bean);
+				if (dialog.getShell() != null) {
+					dialog.getShell().setActive();
+				}
+				
+				List<String> errors = dialog.columns.getManager().validateParametersDefinition();
+				if (errors.size() > 0) {
+					errorOpen = true;
+				}
+				else {
+					if (dialog.getMustShowDialog()) {
+						retOpen = dialog.open() == ParametersDialog2.OK;
+					}
+					else { // fields initialized by 'args'
+						
+						if (!dialog.initializeMacroVariables()) {
+							Log.severe(NLS.bind("{0} fields not updated correctly with {1}", bean, dialog.getParameterManager().getFinalValues()));
+							retOpen = false;
+							return returnCode();
+						}
+						
+						if (!dialog.saveDefaultParameters()) {
+							Log.warning("Could not save parameters for next call");
+						}
+						
+						retOpen = true;
+						errorOpen = false;
+					}
+					
+					if (bean instanceof groovy.lang.Script) { // reset the timer binding if already existing
+						groovy.lang.Script script = (groovy.lang.Script) bean;
+						if (script.getBinding().hasVariable("timer")) {
+							Timer timer = (Timer) script.getBinding().getVariable("timer");
+							timer.reset();
+						}
+					}
+				}
+				
+				return returnCode();
+			}
+		};
+		
+		Display.getDefault().syncExec(new Runnable() {
+			
+			@Override
+			public void run() {
+				try {
+					r.call();
+				}
+				catch (Exception e) {
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				}
+			}
+		});
+		
+		try {
+			return r.call();
+		}
+		catch (Exception e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+			return false;
+		}
+	}
+	
+	/**
+	 * can use the args map to initialize variable not set with the dialog box
+	 */
+	protected boolean initializeMacroVariables() {
+		
+		// System.out.println("Initialize macro variables of "+fieldNames);
+		if (bean == null) return false;
+		
+		return manager.finalToBean(bean);
+	}
+}

Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/AtestClass.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/AtestClass.java	(revision 0)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/AtestClass.java	(revision 3022)
@@ -0,0 +1,46 @@
+package org.txm.rcp.swt.widget.parameters;
+
+import java.io.File;
+import java.util.Date;
+
+import org.kohsuke.args4j.Option;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
+
+public class AtestClass {
+	
+	@Option(name = "file", usage = "a file", widget = "File", required = true, def = "aFile.ext")
+	File file;
+	
+	@Option(name = "dir", usage = "a directory", widget = "Folder", def = "TEMP")
+	File dir;
+	
+	@Option(name = "ii", usage = "an integer", widget = "Integer", def = "42")
+	Integer ii;
+	
+	@Option(name = "f", usage = "a float", widget = "Float", def = "42.42")
+	Float f;
+	
+	@Option(name = "shs", usage = "a one line string", widget = "String", def = "default value")
+	String shs;
+	
+	@Option(name = "ls", usage = "a very long string with carriage return and stuffs", widget = "Text", def = "default\nvalue")
+	String ls;
+	
+	@Option(name = "q", usage = "a CQL", widget = "Query", def = "\"je\"")
+	CQLQuery q;
+	
+	@Option(name = "date", usage = "a date", widget = "Date", def = "1984-09-01")
+	Date date;
+	
+	@Option(name = "bool", usage = "a boolean", widget = "Boolean", def = "true")
+	Boolean bool;
+	
+	public AtestClass() {
+		
+	}
+	
+	@Override
+	public String toString() {
+		return "file=" + file + " dir=" + dir + " ii=" + ii;
+	}
+}

Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/AScript.groovy
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/AScript.groovy	(revision 3021)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/AScript.groovy	(revision 3022)
@@ -1,7 +1,7 @@
 package org.txm.rcp.swt.widget.parameters;
 import org.kohsuke.args4j.*
+
 import groovy.transform.Field
-import org.txm.rcp.swt.widget.parameters.ParametersDialog
 
 @Field @Option(name="file", usage="a file", widget="File", required=true, def="aFile.ext")
 def file
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersGLComposite.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersGLComposite.java	(revision 0)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersGLComposite.java	(revision 3022)
@@ -0,0 +1,255 @@
+package org.txm.rcp.swt.widget.parameters;
+
+import java.util.ArrayList;
+import java.util.LinkedHashMap;
+
+import org.eclipse.jface.dialogs.IDialogConstants;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.SelectionAdapter;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Label;
+import org.kohsuke.args4j.NamedOptionDef;
+import org.kohsuke.args4j.spi.OptionHandler;
+import org.txm.rcp.messages.TXMUIMessages;
+import org.txm.rcp.swt.GLComposite;
+
+/**
+ * Display parameters in specialized widget
+ * 
+ * @author mdecorde
+ *
+ */
+public class ParametersGLComposite extends GLComposite {
+	
+	ParametersManager manager;
+	
+	LinkedHashMap<String, ParameterField> widgets = new LinkedHashMap<>();
+	
+	public int MAX_PARAMETERS_PER_LINE = 10;
+	
+	public boolean mustShowDialog = true;
+	
+	private GLComposite columns;
+	
+	private int numberOfParameters;
+	
+	private int numberOfMandatoryFields;
+	
+	public ParametersGLComposite(Composite parent, int style, String name, ParametersManager manager) {
+		super(parent, style, name);
+		this.manager = manager;
+		
+		// Button propButton = createButton(this, IDialogConstants.BACK_ID,
+		// "...", false);
+		// propButton.removeListener(SWT.Selection, propButton.getListeners(SWT.Selection)[0]);
+		//
+		// propButton.addSelectionListener(new SelectionAdapter() {
+		// @Override
+		// public void widgetSelected(SelectionEvent e) {
+		// FileDialog dialog = new FileDialog(e.display.getActiveShell());
+		// dialog.setFilterPath(propFile.getParent());
+		// dialog.setFilterExtensions(new String[] {"*.properties"});
+		// dialog.setFileName(propFile.getName());
+		// String path = dialog.open();
+		// if (path != null) {
+		// propFile = new File(path);
+		// loadDefaultValuesFromPropFile();
+		// }
+		// }
+		// });
+		
+		buildFields();
+		
+		Button button = new Button(parent, SWT.PUSH);
+		button.removeListener(SWT.Selection, button.getListeners(SWT.Selection)[0]);
+		
+		button.addSelectionListener(new SelectionAdapter() {
+			
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				resetWidgets();
+			}
+		});
+	}
+	
+	public ParametersManager getManager() {
+		return manager;
+	}
+	
+	public void resetWidgets() {
+		// System.out.println("Reseting fields to default values");
+		for (String k : widgets.keySet()) {
+			widgets.get(k).resetToDefault();
+		}
+	}
+	
+	/**
+	 * Build the fields depending on the values parameters and default values
+	 * 
+	 * @param parent
+	 */
+	public void buildFields() {
+		
+		if (columns != null && !columns.isDisposed()) {
+			columns.dispose();
+			widgets.clear();
+		}
+		
+		columns = new GLComposite(this, SWT.NONE, "columns");
+		columns.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
+		columns.getLayout().numColumns = 1;
+		
+		// scrolledComposite.setContent(columns);
+		// scrolledComposite.addListener( SWT.Resize, event -> {
+		// int width = scrolledComposite.getClientArea().width;
+		// scrolledComposite.setMinSize( composite.computeSize( width, SWT.DEFAULT ) );
+		// } );
+		
+		// count the number of fields to show. If "0" then don't show the dialog, see the "open()" function
+		// and select only the NamedOptionDef annotations
+		numberOfParameters = 0; // number of parameters not set by args
+		numberOfMandatoryFields = 0;
+		LinkedHashMap<String, Object> defaultValues = manager.getDefaultValues();
+		for (NamedOptionDef option : manager.parameters.values()) {
+			if (defaultValues.containsKey(option.name())) {
+				continue; // don't show the field
+			}
+			
+			// count number of mandatory fields set AND add exception for "Separator" widget types
+			if (option.required() || "Separator".equals(option.widget())) numberOfMandatoryFields++;
+			numberOfParameters++;
+		}
+		
+		mustShowDialog = numberOfMandatoryFields > 0 || (defaultValues.size() == 0 && numberOfParameters > 0);
+		
+		if (numberOfParameters > MAX_PARAMETERS_PER_LINE) {
+			columns.getLayout().numColumns = 1 + (numberOfParameters / MAX_PARAMETERS_PER_LINE);
+		}
+		
+		GLComposite column = new GLComposite(columns, SWT.NONE, "column");
+		GridData gdata = new GridData(SWT.FILL, SWT.FILL, true, true);
+		gdata.minimumWidth = 200;
+		column.setLayoutData(gdata);
+		column.getLayout().makeColumnsEqualWidth = false;
+		
+		// initialize each widget + default value *of the widget*
+		int n = 0;
+		for (NamedOptionDef option : manager.getParameters().values()) {
+			n++;
+			if (n % MAX_PARAMETERS_PER_LINE == 0) {
+				column = new GLComposite(columns, SWT.NONE, "column");
+				gdata = new GridData(SWT.FILL, SWT.FILL, true, true);
+				gdata.minimumWidth = 200;
+				column.setLayoutData(gdata);
+				column.getLayout().makeColumnsEqualWidth = false;
+			}
+			
+			// each widget is initialized with de default value set in @Field@def attribute
+			String widgetName = option.widget();
+			ParameterField widget = null;
+			if ("File".equals(widgetName) || "FileOpen".equals(widgetName)) { //$NON-NLS-1$
+				widget = new FileField(column, SWT.NONE, option);
+			}
+			else if ("CreateFile".equals(widgetName) || "FileSave".equals(widgetName)) { //$NON-NLS-1$
+				widget = new CreateFileField(column, SWT.NONE, option);
+			}
+			else if ("Folder".equals(widgetName)) { //$NON-NLS-1$
+				widget = new FolderField(column, SWT.NONE, option);
+			}
+			else if ("Query".equals(widgetName)) { //$NON-NLS-1$
+				widget = new QueryField(column, SWT.NONE, option);
+			}
+			else if ("Date".equals(widgetName)) { //$NON-NLS-1$
+				widget = new DateField(column, SWT.NONE, option);
+			}
+			else if ("Time".equals(widgetName)) { //$NON-NLS-1$
+				widget = new TimeField(column, SWT.NONE, option);
+			}
+			else if ("Separator".equals(widgetName)) { //$NON-NLS-1$
+				widget = new SeparatorField(column, SWT.NONE, option);
+			}
+			else if ("String".equals(widgetName)) { //$NON-NLS-1$
+				widget = new StringField(column, SWT.NONE, option);
+			}
+			else if ("Password".equals(widgetName)) { //$NON-NLS-1$
+				widget = new PasswordField(column, SWT.NONE, option);
+			}
+			else if ("StringArray".equals(widgetName)) { //$NON-NLS-1$
+				widget = new StringArrayField(column, SWT.NONE, option);
+			}
+			else if ("StringArrayMultiple".equals(widgetName)) { //$NON-NLS-1$
+				widget = new StringArrayMultipleField(column, SWT.NONE, option);
+			}
+			else if ("StructuralUnits".equals(widgetName)) { //$NON-NLS-1$
+				widget = new CospusStructuresField(column, SWT.NONE, option);
+			}
+			else if ("Text".equals(widgetName)) { //$NON-NLS-1$
+				widget = new LongStringField(column, SWT.NONE, option);
+			}
+			else if ("Integer".equals(widgetName)) { //$NON-NLS-1$
+				widget = new IntegerField(column, SWT.NONE, option);
+			}
+			else if ("Float".equals(widgetName)) { //$NON-NLS-1$
+				widget = new FloatField(column, SWT.NONE, option);
+			}
+			else if ("Boolean".equals(widgetName)) { //$NON-NLS-1$
+				widget = new BooleanField(column, SWT.NONE, option);
+			}
+			else {
+				System.out.println(TXMUIMessages.unknowedWidgetNameColon + widgetName + TXMUIMessages.FileTreeContentProvider_4);
+			}
+			
+			if (widget != null) {
+				widgets.put(option.name(), widget);
+				
+				// set default value in the fields, not enough if args contains the value
+				Object value = defaultValues.get(option.name());
+				if (value != null) { // set the default value using the properties stored
+					widget.setDefault(value.toString());
+				}
+			}
+		}
+	}
+	
+	/**
+	 * 
+	 * @return the number of fields after the buildWidgets is called
+	 */
+	public int getNumberOfParameters() {
+		return numberOfParameters;
+	}
+	
+	/**
+	 * 
+	 * @return the number of mandatory fields after the buildWidgets is called
+	 */
+	public int getNumberOfMandatoryFields() {
+		return numberOfMandatoryFields;
+	}
+	
+	/**
+	 * 
+	 * @return the number of fields after the buildWidgets is called
+	 */
+	public int getNumberOfFields() {
+		return widgets.size();
+	}
+	
+	public ArrayList<String> getNonSetFields() {
+		ArrayList<String> missing = new ArrayList<>();
+		
+		if (manager.getParameters() == null) return missing; // no constraint
+		
+		LinkedHashMap<String, Object> finalValues = manager.getFinalValues();
+		
+		for (NamedOptionDef p : manager.getParameters().values()) {
+			if (p.required() && finalValues.get(p.name()) == null) {
+				missing.add(p.name());
+			}
+		}
+		return missing;
+	}
+}

